



;;;--------------------------------------------------------------------------;
(VMON)
(PRINC        "LISP FOR AutoCAD ")
;;;------------------------------LISP OF A-----------------------------------;
(DEFUN C:A   () (COMMAND "ARC"))
(DEFUN C:AE  () (COMMAND "AREA" "E"))
(DEFUN C:AP  () (COMMAND "APERTURE"))
(DEFUN C:APP () (COMMAND "APPLOAD" ""))
(DEFUN C:ax  () (COMMAND "ai_box"))
(DEFUN C:AA  () (COMMAND "AREA"))
(DEFUN C:AD  () (COMMAND "ARC" PAUSE "E" PAUSE "A" "180" ""))
(DEFUN C:AR  () (COMMAND "array"))
(DEFUN C:AV  () (COMMAND "SH" "AV"))
(PRINC)
;;;------------------------------LISP OF B-----------------------------------;
(DEFUN C:B   () (COMMAND "BREAK" PAUSE "F"))
(DEFUN C:BB  () (COMMAND "BREAK" PAUSE "F" PAUSE "@"))
(DEFUN C:BM  () (COMMAND "BLIPMODE" "OFF")(COMMAND "REDRAW"))
(DEFUN C:BL  () (COMMAND "BLOCK"))
(DEFUN C:BP  () (COMMAND "BPOLY"))
(PRINC)
;;;------------------------------LISP OF C-----------------------------------;
(DEFUN C:C   () (COMMAND "COPY"))
(DEFUN C:CX  () (COMMAND "COPY" "P"))
(DEFUN C:C0  () (COMMAND "CHANGE" "C" PAUSE PAUSE "" "P" "E" "0" ""))
;....................................................
(defun c:ca (/ tx ty tz tar cam)
  (setq tx (+ (car (getvar "target")) (car (getvar "viewdir"))))
  (setq ty (+ (cadr (getvar "target")) (cadr (getvar "viewdir"))))
  (setq tx (+ (caddr (getvar "target")) (caddr (getvar "viewdir"))))
  (setq tar (list tx ty tz))
  (setq cam (getvar "target"))
  (command "dview" "c" pause pause pause "po" tar cam)
)
;....................................................
(defun c:cc (/ a2 b2 l1 l2)
    (graphscr)
    (prompt "select entity on target layer ") (terpri)
    (setq a2 (entsel))
    (setq b2 (entget (car a2)))
    (setq l1 (assoc 8 b2))
    (setq l2 (cdr l1))
   (command "layer" "s" l2 "")
(princ)
)
;....................................................
(DEFUN C:CEN () (COMMAND "OSNAP" "CEN"))
(DEFUN C:CI  () (COMMAND "CIRCLE"))
(DEFUN C:CD  () (COMMAND "CIRCLE" "2P" PAUSE PAUSE ""))
(DEFUN C:CH  () (COMMAND "CHANGE"))
(DEFUN C:CF  () (COMMAND "CHAMFER"))
;(DEFUN C:CC () (COMMAND "COPY" "C" "M" ""))
(PRINC)
;;;------------------------------LISP OF D-----------------------------------;
(DEFUN C:D   () (COMMAND "dist"))
(DEFUN C:DD  () (COMMAND "DDlmodes"))
(DEFUN C:DDC () (COMMAND "ddchprop" ""))
(DEFUN C:DDD () (COMMAND "DIVIDE"))
(DEFUN C:DE  () (COMMAND "DDEDIT"))
(DEFUN C:ddi () (COMMAND "insert" "~" ))
(DEFUN C:DIC () (COMMAND "SH" "DIC"))
(DEFUN C:DO  () (COMMAND "DONUT"))
;(DEFUN C:DM  () (COMMAND "DDIM"))
;(DEFUN C:DN  () (COMMAND "SH" "DN"))
(DEFUN C:DOS () (COMMAND "sh" "dosshell"))
(DEFUN C:DT  () (COMMAND "DTEXT"))
(DEFUN C:DW  () (COMMAND "DVIEW"))
(PRINC)
;....................**DIMENSION**.................;
(DEFUN C:DI  () (COMMAND "DIM"))
;(DEFUN C:DH  () (COMMAND "DIM" "DIMTAD" "1" "HOR"))
(DEFUN C:DH0 () (COMMAND "DIM" "DIMTAD" "0" "HOR"))
(DEFUN C:DHO () (COMMAND "DIM" "HOM"))
;(DEFUN C:DV  () (COMMAND "DIM" "DIMTIH" "0" "VER"))
(DEFUN C:DV1 () (COMMAND "DIM" "DIMTIH" "1" "VER"))
(DEFUN C:DAL () (COMMAND "DIM" "DIMTIH" "0" "AL"))
(DEFUN C:DH  () (COMMAND "LAYER" "S" "DIM" "" "")(COMMAND "DIM" "DIMTAD" "1" "HOR"))
;(DEFUN C:DH  () (COMMAND "DIM" "DIMTAD" "1" "HOR")(COMMAND "CHANGE" "L" "" "P" "LA" "DIM" "CO" "BYLAYER" ""))
;(DEFUN C:DV  () (COMMAND "DIM" "DIMTIH" "0" "VER")(COMMAND "CHANGE" "L" "" "P" "LA" "DIM" "CO" "BYLAYER" ""))
(DEFUN C:DV  () (COMMAND "LAYER" "S" "DIM" "" "")(COMMAND "DIM" "DIMTIH" "0" "VER"))
(DEFUN C:DAN () (COMMAND "DIM" "AN"))
(DEFUN C:DLL () (COMMAND "DIM" "L"))
(DEFUN C:DTT () (COMMAND "DIM" "TE"))
(DEFUN C:DTE () (COMMAND "DIM"  "TROTATE" "90"))
(DEFUN C:DTY () (COMMAND "DIM"  "TROTATE" "-90"))
(DEFUN C:DTR () (COMMAND "DIM" "TROTATE"))
(DEFUN C:DN  () (COMMAND "DIM" "N"))
(DEFUN C:DU  () (COMMAND "DIM" "UP"))

;.................... DRAW DOORS............................;
(defun c:d1 (/ p1 p2 p3 p4 p5 p6 p7 p7 p8 p9 p10 d1 ss1 p6a p20 p21 d an e ss l ss1 b c)
(setq os (getvar "osmode"))
(setvar "osmode" 0)
(setq cla(getvar "clayer"))
(setq p1 (getpoint "\nEnter Left Point"))
(setq p2 (getpoint "\nEnter Right Point"))
(setq d (distance p1 p2))
(setq d1 (/ d 2))
(setq an (angle p1 p2))
(setq e (/ pi 2))
(setq e (+ e an))
(setq p3 (polar p1 e 0.01))
(setq p4 (polar p1 an 0.05))
(setq p5 (polar p4 e 0.07))
(setq p6 (polar p5 an -0.02))
(setq p7 (polar p6 e 0.03))
(setq p8 (polar p7 an -0.03))
(setq p9 (polar p8 e -0.01))
(setq p10 (polar p1 an d1))
(setq p6a (polar p6 an 0.005))
(SETQ P6C (POLAR P6A  E 0.005))
(setq p6b (polar p6c an 0.05))
(setq p20a (polar p6b e (- d 0.07)))
(setq p20 (polar p6c e (- d 0.07)))
(setq p21 (polar p6b an (- d 0.12)))
(grdraw p6b p20a 1 -1)
(grdraw p21 p20a 1 -1)
(initget 1 "y n")
(setq l (getkword "\n mirror door <y/n>: "))
(setq b (getvar "blipmode"))
(setq c (getvar "cmdecho"))
(setvar "blipmode" 0)
(setvar "cmdecho" 0)
(setq la (tblsearch "layer" "door"))
(if(= la nil)
(command "layer" "m" "door" "c" "1" "" "")
(command "layer" "s" "door" ""))
(command "pline" p3 p1 p4 p5 p6 p7 p8 p9 "")
(command "mirror" "l" "" p10 (polar p10 e 0.5) "n")
(command "arc" p21 "e" p20a "a" 90)
(if (= l "y") (command "mirror" "l" "" p10 (polar p10 e 5) "y"))
(command "pline" p6c p6b p20a p20 "c")
(if (= l "y")(command "mirror" "l" "" p10 (polar p10 e 5) "y"))
(redraw)
(setvar "blipmode" b)
(setvar "cmdecho" c)
(setvar "osmode" os)
(setvar "clayer" cla)
)
(defun c:d11 (/ p1 p2 p3 p4 p5 p6 p7 p7 p8 p9 p10 d1 ss1 p6a p20 p21 d an e ss l ss1 b c)
(setq os (getvar "osmode"))
(setvar "osmode" 0)
(setq cla(getvar "clayer"))
(setq p1 (getpoint "\nEnter Left Point"))
(setq p2 (getpoint "\nEnter Right Point"))
(setq d (distance p1 p2))
(setq d1 (/ d 2))
(setq an (angle p1 p2))
(setq e (/ pi 2))
(setq e (+ e an))
(setq p3 (polar p1 e 1))
(setq p4 (polar p1 an 5))
(setq p5 (polar p4 e 7))
(setq p6 (polar p5 an -2))
(setq p7 (polar p6 e 3))
(setq p8 (polar p7 an -3))
(setq p9 (polar p8 e -1))
(setq p10 (polar p1 an d1))
(setq p6a (polar p6 an 0.5))
(SETQ P6C (POLAR P6A  E 0.5))
(setq p6b (polar p6c an 5))
(setq p20a (polar p6b e (- d 7)))
(setq p20 (polar p6c e (- d 7)))
(setq p21 (polar p6b an (- d 12)))
(grdraw p6b p20a 1 -1)
(grdraw p21 p20a 1 -1)
(initget 1 "y n")
(setq l (getkword "\n mirror door <y/n>: "))
(setq b (getvar "blipmode"))
(setq c (getvar "cmdecho"))
(setvar "blipmode" 0)
(setvar "cmdecho" 0)
(setq la (tblsearch "layer" "door"))
(if(= la nil)
(command "layer" "m" "door" "c" "1" "" "")
(command "layer" "s" "door" ""))
(command "pline" p3 p1 p4 p5 p6 p7 p8 p9 "")
(command "mirror" "l" "" p10 (polar p10 e 50) "n")
(command "arc" p21 "e" p20a "a" 90)
(if (= l "y") (command "mirror" "l" "" p10 (polar p10 e 500) "y"))
(command "pline" p6c p6b p20a p20 "c")
(if (= l "y")(command "mirror" "l" "" p10 (polar p10 e 500) "y"))
(redraw)
(setvar "blipmode" b)
(setvar "cmdecho" c)
(setvar "osmode" os)
(setvar "clayer" cla)
)
;.................................................
(defun c:d2 ()
(setq blip (getvar "blipmode"))
(setq cmd (getvar "cmdecho"))
(setq cla (getvar "clayer"))
(setvar "blipmode" 0)
(setvar "osmode" 0)
(setvar "cmdecho" 0)
(setq p1 (getpoint "\nPlease Enter Big Door Point:"))
(setq p2 (getpoint "\nPlease Enter Small Door Point:"))
(setq d (distance p1 p2))
(setq d1 (/ d 2))
(setq an (angle p1 p2))
(setq e (/ pi 2))
(setq e (+ e an))
(setq I (getreal"\nPLEASE ENTER LENGTH OF BIG DIOOR :"))
(setq ch (- d I))
(setq p3 (polar p1 e 0.01))
(setq p4 (polar p1 an 0.05))
(setq p5 (polar p4 e 0.07))
(setq p6 (polar p5 an -0.02))
(setq p7 (polar p6 e 0.03))
(setq p8 (polar p7 an -0.03))
(setq p9 (polar p8 e -0.01))
(setq p10 (polar p1 an d1))
(setq p6a (polar p6 an 0.005))
(setq p6c (polar P6a e  0.005))
(setq p6b (polar p6c an 0.05))
(setq p20a (polar p6b e (- I 0.07)))
(setq p20 (polar p6c e (- I 0.07)))
(setq p21 (polar p1 an i))
(setq p6d (polar p6c an (- d 0.12)))
(setq p6e (polar p6d an 0.05))
(setq p6f (polar p6d e (- ch 0.07)))
(setq p6h (polar p6e e (- ch 0.07)))
(setq la (tblsearch "layer" "door"))
(if (= la nil)
(command "layer" "m" "door" "c" "1" "" "")
(command "layer" "s" "door" ""))
(command "pline" p3 p1 p4 p5 p6 p7 p8 p9 "")
(command "mirror" "l" "" p10 (polar p10 e 0.5) "n")
(command "arc" p21 "e" p20a "a" 90)
(if (= ch i)(command "mirror" "l" "" p10 (polar p10 e 5) "n")(command "arc" p6f "e" p21 "a" 90))
(command "pline" p6c p6b p20a p20 "c")
(if (= ch i)(command "mirror" "l" "" p10 (polar p10 e 5) "n")(command "pline" p6d p6f p6h  p6e "c"))
(setvar "blipmode" blip)
(setvar "cmdecho" cmd)
(setvar "osmode" os)
(setvar "clayer" cla))
;;.............................................................
(defun c:d22 ()
(setq blip (getvar "blipmode"))
(setq cmd (getvar "cmdecho"))
(setq cla (getvar "clayer"))
(setvar "blipmode" 0)
(setvar "osmode" 0)
(setvar "cmdecho" 0)
(setq p1 (getpoint "\nPlease Enter Big Door Point:"))
(setq p2 (getpoint "\nPlease Enter Small Door Point:"))
(setq d (distance p1 p2))
(setq d1 (/ d 2))
(setq an (angle p1 p2))
(setq e (/ pi 2))
(setq e (+ e an))
(setq I (getreal"\nPLEASE ENTER LENGTH OF BIG DIOOR :"))
(setq ch (- d I))
(setq p3 (polar p1 e 1))
(setq p4 (polar p1 an 5))
(setq p5 (polar p4 e 7))
(setq p6 (polar p5 an -2))
(setq p7 (polar p6 e 3))
(setq p8 (polar p7 an -3))
(setq p9 (polar p8 e -1))
(setq p10 (polar p1 an d1))
(setq p6a (polar p6 an 0.5))
(setq p6c (polar P6a e  0.5))
(setq p6b (polar p6c an 5))
(setq p20a (polar p6b e (- I 7)))
(setq p20 (polar p6c e (- I 7)))
(setq p21 (polar p1 an i))
(setq p6d (polar p6c an (- d 12)))
(setq p6e (polar p6d an 5))
(setq p6f (polar p6d e (- ch 7)))
(setq p6h (polar p6e e (- ch 7)))
(setq la (tblsearch "layer" "door"))
(if (= la nil)
(command "layer" "m" "door" "c" "1" "" "")
(command "layer" "s" "door" ""))
(command "pline" p3 p1 p4 p5 p6 p7 p8 p9 "")
(command "mirror" "l" "" p10 (polar p10 e 50) "n")
(command "arc" p21 "e" p20a "a" 90)
(if (= ch i)(command "mirror" "l" "" p10 (polar p10 e 5) "n")(command "arc" p6f "e" p21 "a" 90))
(command "pline" p6c p6b p20a p20 "c")
(if (= ch i)(command "mirror" "l" "" p10 (polar p10 e 5) "n")(command "pline" p6d p6f p6h  p6e "c"))
(setvar "blipmode" blip)
(setvar "cmdecho" cmd)
(setvar "osmode" os)
(setvar "clayer" cla))

;.................................................

;;;------------------------------LISP OF E-----------------------------------;
(DEFUN C:E   () (COMMAND "ERASE"))
(DEFUN C:E0  () (COMMAND "ELEV" "0" "0" ""))
(DEFUN C:EDIT() (COMMAND "shELL" "edit"  ))
;................................................
;(defun c:edg (/ a b1 b2 b3 b4)
;(setq a (ssget))
;(if (= (sslength a) 4)
;(progn
;(setq b1 (cdr (assoc 10 (entget (entnext (ssname a 0))))))
;(setq b2 (cdr (assoc 10 (entget (entnext (ssname a 1))))))
;(setq b3 (cdr (assoc 10 (entget (entnext (ssname a 2))))))
;(setq b4 (cdr (assoc 10 (entget (entnext (entnext (ssname a 3)))))))
;(command "edgesurf" b1 b2 b3 b4)
; )
;)
;(if (/= (sslength a) 4) (prompt "\nExactly 4 edges not found: "))
;)
;............................................
(DEFUN C:EE  () (COMMAND "EXTEND"))
(DEFUN C:EF  () (COMMAND "EXTEND" PAUSE PAUSE "F"))
(DEFUN C:ENN () (COMMAND "OSNAP" "END"))
(DEFUN C:EL  () (COMMAND "ELEV"))
(DEFUN C:EX  () (COMMAND "EXPLODE"))
(defun c:txtexp (/ grplst getgname mtextbox ucs_2_mtext FLTR GLST GDICT SS VIEW
                   UPLFT TMPFIL TMPFIL CNT PT1 PT2 ENT TXT TXTTYP PTLST ZM LOCKED)
  (init_bonus_error
        (list
         (list   "cmdecho" 0
                 "highlight" 1
         )
         T
        )
  )

; --------------------- GROUP LIST FUNCTION ----------------------
;   This function will return a list of all the group names in the
;   drawing and their entity names in the form:
;   ((<ename1> . <name1>) ... (<enamex> . <namex>))
; ----------------------------------------------------------------

  (defun grplst (/ GRP MSTR ITM NAM ENT GLST)

    (setq GRP  (dictsearch (namedobjdict) "ACAD_GROUP"))
    (while (setq ITM (car GRP))       ; While edata item is available
      (if (= (car ITM) 3)             ; if the item is a group name
        (setq NAM (cdr ITM)           ; get the name
              GRP (cdr GRP)           ; shorten the edata
              ITM (car GRP)           ; get the next item
              ENT (cdr ITM)           ; which is the ename
              GRP (cdr GRP)           ; shorten the edata
              GLST                    ; store the ename and name
                  (if GLST
                    (append GLST (list (cons ENT NAM)))
                    (list (cons ENT NAM))
                  )
        )
        (setq GRP (cdr GRP))          ; else shorten the edata
      )
    )
    GLST                              ; return the list
  )

; ------------------- GET GROUP NAME FUNCTION --------------------
;   This function returns a list of all the group names in GLST
;   where ENT is a member. The list has the same form as GLST
; ----------------------------------------------------------------

  (defun getgname (ENT GLST / MSTR GRP GDATA ITM NAM NLST)
    (if (and GLST (listp GLST))
      (progn
        (foreach GRP GLST
          (setq GDATA (entget (car GRP)))
          (foreach ITM GDATA                   ; step through the edata
            (if (and
                  (= (car ITM) 340)            ; if the item is a entity name
                  (eq (setq NAM (cdr ITM)) ENT) ; and the ename being looked for
                )
              (setq NLST                       ; store the ename and name
                      (if NLST
                        (append NLST (list (cons (car GRP) (cdr GRP))))
                        (list (cons (car GRP) (cdr GRP)))
                      )
              )
            )
          )
        )
      )
    )
    NLST
  )

; --------------------- MTEXTBOX FUNCTION ------------------------
;   This function returns a list of four points describing the
;   bounding box of the mtext (MTXT).
; ----------------------------------------------------------------

  (defun mtextbox (MTXT / WDTH HGHT INS JUST ANG P1 P2 P3 P4)
    (if (and (listp MTXT) (= "MTEXT" (cdr (assoc 0 MTXT))))
      (progn
        (setq WDTH (cdr (assoc 42 MTXT))
              HGHT (cdr (assoc 43 MTXT))
              INS  (trans (cdr (assoc 10 MTXT)) 0 1)
              JUST (cdr (assoc 71 MTXT))
              ANG  (cdr (assoc 50 MTXT))
        )
        (cond
          ((= JUST 1)
            (setq P1 (polar INS (- ANG (* Pi 0.5)) HGHT) ; lower-left
                  P2 (polar P1 ANG WDTH)                 ; lower-right
                  P3 (polar INS ANG WDTH)                ; upper-right
                  p4 INS                                 ; upper-left
            )
          )
          ((= JUST 2)
            (setq P3 (polar INS ANG (/ WDTH 2))
                  P4 (polar INS (+ ANG Pi) (/ WDTH 2))
                  P1 (polar P4 (- ANG (* Pi 0.5)) HGHT)
                  P2 (polar P1 ANG WDTH)
            )
          )
          ((= JUST 3)
            (setq P3 INS
                  P4 (polar INS (+ ANG Pi) WDTH)
                  P1 (polar P4 (- ANG (* Pi 0.5)) HGHT)
                  P2 (polar P1 ANG WDTH)
            )
          )
          ((= JUST 4)
            (setq P4 (polar INS (+ ANG (* Pi 0.5)) (/ HGHT 2))
                  P3 (polar P4 ANG WDTH)
                  P1 (polar P4 (- ANG (* Pi 0.5)) HGHT)
                  P2 (polar P1 ANG WDTH)
            )
          )
          ((= JUST 5)
            (setq P4 (polar INS (- ANG Pi) (/ WDTH 2))
                  P4 (polar P4 (+ ANG (* Pi 0.5)) (/ HGHT 2))
                  P3 (polar P4 ANG WDTH)
                  P1 (polar P4 (- ANG (* Pi 0.5)) HGHT)
                  P2 (polar P1 ANG WDTH)
            )
          )
          ((= JUST 6)
            (setq P3 (polar INS (+ ANG (* Pi 0.5)) (/ HGHT 2))
                  P4 (polar P3 (+ ANG Pi) WDTH)
                  P1 (polar P4 (- ANG (* Pi 0.5)) HGHT)
                  P2 (polar P1 ANG WDTH)
            )
          )
          ((= JUST 7)
            (setq P1 INS
                  P2 (polar P1 ANG WDTH)
                  P3 (polar P2 (+ ANG (* Pi 0.5)) HGHT)
                  P4 (polar P1 (+ ANG (* Pi 0.5)) HGHT)
            )
          )
          ((= JUST 8)
            (setq P1 (polar INS (+ ANG Pi) (/ WDTH 2))
                  P2 (polar P1 ANG WDTH)
                  P3 (polar P2 (+ ANG (* Pi 0.5)) HGHT)
                  P4 (polar P1 (+ ANG (* Pi 0.5)) HGHT)
            )
          )
          ((= JUST 9)
            (setq P2 INS
                  P1 (polar INS (+ ANG Pi) WDTH)
                  P3 (polar P2 (+ ANG (* Pi 0.5)) HGHT)
                  P4 (polar P1 (+ ANG (* Pi 0.5)) HGHT)
            )
          )
        )
      )
      (prompt "\nEntity Not Mtext!")
    )
    (list P1 P2 P3 P4)
  )

; ------------------- SET MTEXT UCS FUNCTION ---------------------
;   AutoCAD does not accept mtext as a valid object for setting
;   the ucs. This function will set the current ucs to the
;   mtext entity name ENT.
; ----------------------------------------------------------------

  (defun ucs_2_mtext (ENT / PTZ PTX PTY PTO)

    (setq PTZ (trans (cdr (assoc 210 (entget ENT))) ENT 1 T)
          PTX (trans (cdr (assoc 11 (entget ENT))) ENT 1 T)
          PTO (trans (cdr (assoc 10 (entget ENT))) ENT 1)
          PTY (list
                (-
                  (* (cadr PTZ) (caddr PTX))
                  (* (cadr PTX) (caddr PTZ))
                );minus
                (* -1
                  (-
                    (* (car PTZ) (caddr PTX))
                    (* (car PTX) (caddr PTZ))
                  );minus
                );multiply by -1
                (-
                  (* (car PTZ) (cadr PTX))
                  (* (car PTX) (cadr PTZ))
                );minus
              );list
          PTX (list (+ (car PTO) (car PTX))
                    (+ (cadr PTO) (cadr PTX))
                    (+ (caddr PTO) (caddr PTX))
              )
          PTY (list (+ (car PTO) (car PTY))
                    (+ (cadr PTO) (cadr PTY))
                    (+ (caddr PTO) (caddr PTY))
              )

    );setq
    (command "_.ucs" "_3" PTO PTX PTY)
  )

; ----------------------------------------------------------------
;                          MAIN PROGRAM
; ----------------------------------------------------------------

  (if (and                                                ; Are we in plan view?
        (equal (car (getvar "viewdir")) 0 0.00001)
        (equal (cadr (getvar "viewdir")) 0 0.00001)
        (> (caddr (getvar "viewdir")) 0)
      )

    (progn

      (prompt "\nSelect text to be EXPLODED: ")

      (Setq FLTR    '((-4 . "<AND")
                        (-4 . "<OR")                      ; filter for mtext and text
                          (0 . "MTEXT")
                          (0 . "TEXT")
                        (-4 . "OR>")
                        (-4 . "<NOT")
                          (102 . "{ACAD_REACTORS")        ; and not leader text
                        (-4 . "NOT>")
                      (-4 . "AND>")
                     )
            GLST     (grplst)                             ; Get all the groups in drawing
            GDICT    (if GLST
                       (dictsearch (namedobjdict) "ACAD_GROUP")
                     )
            SS       (ssget  FLTR)
            CNT      0
      )

      (if SS
        (progn
          (setq CNT (sslength SS))
          (princ (strcat "\n" (itoa CNT) " found."))       ; Report number of items found

          (command "_.move" SS "")                         ; filter out objects on locked layers

          (if (> (getvar "cmdactive") 0)                   ; if there are still objects left
            (progn
              (command "0,0" "0,0")
              (setq SS  (ssget "p" FLTR)
                    CNT (- CNT (sslength SS))              ; count them
              )
            )
            (setq SS nil)                                  ; else abort operation
          )

          (if (> CNT 0)                                    ; if items where filtered out
            (if (= CNT 1)
              (princ (strcat "\n" (itoa CNT) " was on a locked layer."))   ; report it.
              (princ (strcat "\n" (itoa CNT) " were on a locked layer."))
            )
          )
        )
      )

      (if SS
        (progn

          (setq CNT 0)                                 ; Reset counter
          (While (setq ENT (ssname SS CNT))            ; step through each object in set

            (and
              GLST                                     ; if groups are present in the drawing
              (setq GNAM (getgname ENT GLST))          ; and the text item is in one or more
              (foreach GRP GNAM                        ; step through those groups
                (command "_.-group" "_r"               ; and remove the text item
                  (cdr GRP) ENT ""
                )
              )
            )

            (setq TXT   (entget ENT)
                  TXTYP (cdr (assoc 0 TXT))            ; Text or Mtext
            )

            (if (= TXTYP "TEXT")
              (command "_.ucs" "_object" ENT)          ; set UCS to object
               (ucs_2_mtext ENT)
            )

            (if (= TXTYP "TEXT")                       ; get the points for the bounding box
              (progn
                (setq TBX (textbox TXT)                ; normal text
                      TBX (list (car TBX) (list (caadr TBX)(cadar TBX))
                                (cadr TBX) (list (caar TBX)(cadadr TBX))
                          )
                )
              )
              (setq TBX (mtextbox TXT))                ; Mtext
            )

            (setq TBX (mapcar '(lambda (x)
                                 (trans x 1 0)         ; convert the points to WCS
                               )
                        TBX
                      )
            )

            (setq PTLST (append PTLST TBX))            ; Build list of bounding box
                                                       ; points for text items selected


            (command "_.ucs" "_previous")              ; reset the ucs

            (setq CNT (1+ CNT))                        ; get the next text item
          ); while

          (setq PTLST (mapcar '(lambda (x)
                                 (trans x 0 1)         ; convert all the points
                               )                       ; to the current ucs
                      PTLST
                    )
          )

          (if (setq ZM (zoom_4_select PTLST))          ; If current view does not contain
            (progn                                     ; all bounding box points
              (setq ZM
                (list
                  (list (- (caar ZM) (pixel_unit))     ; increase zoom area by
                        (- (cadar ZM) (pixel_unit))    ; one pixel width to
                        (caddar ZM)                    ; sure nothing will be lost
                  )
                  (list (+ (caadr ZM) (pixel_unit))
                        (+ (cadadr ZM) (pixel_unit))
                        (caddr (cadr zm))
                  )
                )
              )
              (command "_.zoom" "_w" (car ZM) (cadr ZM))  ; zoom to include text objects
            )
          )

          (setq VIEW     (viewpnts)
                UPLFT    (list (caar VIEW) (cadadr VIEW))
                TMPFIL   (strcat (getvar "tempprefix") "txtexp.wmf")
                PT1      (getvar "viewctr")
                PT2      (list (car PT1) (cadadr VIEW))
          )

          (if (b_layer_locked (getvar "clayer"))       ; if current layer is locked
            (progn
              (command "_.layer" "_unl" (getvar "clayer") "")  ; unlock it
              (setq LOCKED T)
            )
          )

          (command "_.mirror" SS "" PT1 PT2 "_y"
                   "_.WMFOUT" TMPFIL SS ""
                   "_.ERASE" SS ""
                   "_.WMFIN" TMPFIL UPLFT  "2" "" ""
                   "_.mirror" (entlast) "" PT1 PT2 "_y"
                   "_.EXPLODE" (entlast)
          );end command


          (command "_.erase" (ssget "p") "_R" "_W"
                   (polar (car VIEW) (* 0.25 Pi) (pixel_unit))
                   (cadr VIEW)
                   ""
          )


          (if ZM (command "_.zoom" "_p"))              ; Restore original view if needed
          (if LOCKED (command "_.layer" "_lock" (getvar "clayer") "")) : relock if needed

          (prompt (strcat "\n" (itoa (sslength ss))
                          " text object(s) have been exploded to lines."
                  )
          )
          (prompt "\nThe line objects have been placed on layer 0.")
        )
      )
    )
    (prompt "\nView needs to be in plan (0 0 1).")
  );if equal
  (restore_old_error)                                  ; Retsore values
  (princ)
)

(PRINC)
;;;------------------------------LISP OF F-----------------------------------;
(DEFUN C:F   () (COMMAND "FILLET"))
(DEFUN C:FF  () (COMMAND "FILLET" "F"))
(DEFUN C:FC  () (COMMAND "FILLET" "C"))
(DEFUN C:FI  () (COMMAND "FILES" ))
(DEFUN C:FD  () (COMMAND "3DFACE"))
(DEFUN C:FR  () (COMMAND "FILLET" "R" ))
(PRINC)
;;;------------------------------LISP OF G-----------------------------------;
;;;------------------------------LISP OF H-----------------------------------;
(DEFUN C:H   () (COMMAND "HIDE"))
(PRINC)
;;;------------------------------LISP OF I-----------------------------------;
(DEFUN C:I   () (COMMAND "INSERT" PAUSE "SCALE" "1" pause  ))
;INSERT BLOCK OF DOOR
(DEFUN C:ID1 () (COMMAND "INSERT" "DOOR-1" ))
(DEFUN C:ID2 () (COMMAND "INSERT" "DOOR-2" ))
(DEFUN C:INT () (COMMAND "OSNAP" "INT"))
(DEFUN C:INS () (COMMAND "OSNAP" "INS"))
(PRINC)
;;;------------------------------LISP OF J-----------------------------------;
;..............join text...................
(defun c:jt()
(setq ta (car (entsel "Select First Text : ")))
(setq tb (car (entsel "Select Second Text : ")))
(setq a (cdr (assoc 1 (entget ta))))
(setq b (cdr (assoc 1 (entget tb))))
(setq a (strcat a " " b))
(setq tad (entget ta))
(setq tad (subst (cons 1 a) (assoc 1 tad) tad))
(entmod tad)
(command "erase" tb "")
)
;........................................
;;;------------------------------LISP OF K-----------------------------------;
;;;------------------------------LISP OF L-----------------------------------;
(DEFUN C:LA  () (COMMAND "LAYER" ))
(DEFUN C:LI  () (COMMAND "LIST"))
(defun c:ll (/ a1 a2 n index b1 b2 d1 d2 b3)
    (graphscr)
    (prompt "select entities to be changed ") (terpri)
    (setq a1 (ssget))
    (prompt "point to entity on target layer ") (terpri)
    (setq a2 (entsel))
    (setq n (sslength a1))
    (setq index 0)
    (setq b2 (entget (car a2)))
    (setq d2 (assoc 8 b2))
    (repeat n
        (setq b1 (entget (ssname a1 index)))
        (setq d1 (assoc 8 b1))
        (setq b3 (subst d2 d1 b1))
        (entmod b3)
        (setq index (+ index 1))
    )
(princ)
)
;..................................................
(defun c:lp (/ a b pnt1 pnt2 ang1)
    (graphscr)
    (setq a (entsel))
    (setq b (entget (car a)))
    (setq pnt1 (cdr (assoc 10 b)))
    (setq pnt2 (cdr (assoc 11 b)))
    (setq ang1 (angle pnt1 pnt2))
    (setvar "snapang" ang1)
(princ)
)
(defun c:lpp ()
(setvar "snapang" 0))
;....................................................
(defun c:lf (/ a2 b2 l1 l2)
    (graphscr)
    (prompt "(select entity on target layer to be freez ") (terpri)
    (setq a2 (entsel))
    (setq b2 (entget (car a2)))
    (setq l1 (assoc 8 b2))
    (setq l2 (cdr l1))
   (command "layer" "f" l2 "")
(princ)
)
;..............................................
(defun c:llf (/ a2 b2 l1 l2)
    (graphscr)
    (prompt "(select entity on target layer ") (terpri)
    (setq a2 (entsel))
    (setq b2 (entget (car a2)))
    (setq l1 (assoc 8 b2))
    (setq l2 (cdr l1))
   (command "layer" "off" l2 "")
(princ)
)
;......................................................
(defun C:LC()
  (setq entname nil)
  (while (and (/= "CIRCLE" entname) (/= "ARC" entname))
   (setq e (entsel "\nplease select a circle or an arc: "))
   (setq ename (car e))
   (setq elist (entget ename))
   (setq entname (cdr (assoc 0 elist)))
  )
  (setq red (cdr (assoc 40 elist)))
  (setq cen (cdr (assoc 10 elist)))
  (setq cen (trans cen ename 1))
  (setq p0 (getpoint "\nText insertion point: "))
  (setq h0 (getvar "textsize"))
  (setq p1 (list (car p0) (- (cdr p0) ( * 1.4 h0))))
  (setq p2 (list (car p0) (- (cadr p1) ( * 1.4 h0))))
  (command "text" p0 h0 "" (stract "X="(rtos (car cen) 2 3)))
  (command "text" p1 h0 "" (stract "Y="(rtos (cadr cen) 2 3)))
  (command "text" p2 h0 "" (stract "R="(rtos red 2 3)))
  (princ)
)
;...........................................................
(defun c:lff (/ a2 b2 l1 l2)
    (graphscr)
    (prompt "(select entity on target layer") (terpri)
    (setq a2 (entsel))
    (setq b2 (entget (car a2)))
    (setq l1 (assoc 8 b2))
    (setq l2 (cdr l1))
   (command "layer" "s" l2"")
(command "layer" "off" "*" "" "")
(princ)
)
;.................................................
(DEFUN C:LI  () (COMMAND "LIST"))
(DEFUN C:LT  () (COMMAND "LAYER" "T" "*" "" ""))
(DEFUN C:LO  () (COMMAND "LAYER" "ON" "*" "" ""))
(DEFUN C:LO  () (COMMAND "LAYER" "ON" "*" "" ""))
(DEFUN C:L1  () (COMMAND "LAYER" "S" "1" "" ""))
(DEFUN C:L2  () (COMMAND "LAYER" "S" "2" "" ""))
(DEFUN C:L3  () (COMMAND "LAYER" "S" "3" "" ""))
(DEFUN C:L4  () (COMMAND "LAYER" "S" "4" "" ""))
(DEFUN C:L5  () (COMMAND "LAYER" "S" "5" "" ""))
(DEFUN C:L6  () (COMMAND "LAYER" "S" "6" "" ""))
(DEFUN C:L7  () (COMMAND "LAYER" "S" "7" "" ""))
(DEFUN C:L8  () (COMMAND "LAYER" "S" "8" "" ""))
(DEFUN C:L9  () (COMMAND "LAYER" "S" "9" "" ""))
(DEFUN C:L10 () (COMMAND "LAYER" "S" "10" "" ""))
(DEFUN C:L11 () (COMMAND "LAYER" "S" "11" "" ""))
(DEFUN C:L12 () (COMMAND "LAYER" "S" "12" "" ""))
(DEFUN C:L13 () (COMMAND "LAYER" "S" "13" "" ""))
(DEFUN C:LR  () (COMMAND "LAYER" "S" "RIVER" "" ""))
(DEFUN C:LRR () (COMMAND "LAYER" "S" "RIVER-1" "" ""))
(DEFUN C:LW  () (COMMAND "LAYER" "S" "WIN" "" ""))
(DEFUN C:LD  () (COMMAND "LAYER" "S" "DIM" "" ""))
(DEFUN C:LDO () (COMMAND "LAYER" "S" "DOOR" "" ""))
(DEFUN C:LIT () (COMMAND "LINETYPE" "L" "*" "" ""))
(DEFUN C:LOD  () (LOAD"ACAD.LSP"))
(DEFUN C:LOF () (LOAD"FARSI.LSP"))
(DEFUN C:LOK () (LOAD"KATEB.LSP"))
(DEFUN C:LTS () (COMMAND "LTSCALE"))
;;;------------------------------LISP OF M-----------------------------------;
(DEFUN C:M   () (COMMAND "MOVE"))
(DEFUN C:MN  () (COMMAND "MOVE" "P"))
;(DEFUN C:MP  () (COMMAND "MPEDIT"))
;(DEFUN C:MO  () (COMMAND "SHELL" "MO.BAT"))
(DEFUN C:MM  () (COMMAND "MIRROR"))
(DEFUN C:MT0 () (COMMAND "MIRRTEXT" "0"))
;;..............MAKEING LAYER..................
(DEFUN C:M1  () (COMMAND "LAYER" "N" "1" "M" "1" "C" "1" "" ""))
(DEFUN C:M2  () (COMMAND "LAYER" "N" "2" "M" "2" "C" "2" "" ""))
(DEFUN C:M3  () (COMMAND "LAYER" "N" "3" "M" "3" "C" "3" "" ""))
(DEFUN C:M4  () (COMMAND "LAYER" "N" "4" "M" "4" "C" "4" "" ""))
(DEFUN C:M5  () (COMMAND "LAYER" "N" "5" "M" "5" "C" "5" "" ""))
(DEFUN C:M6  () (COMMAND "LAYER" "N" "6" "M" "6" "C" "6" "" ""))
(DEFUN C:M7  () (COMMAND "LAYER" "N" "7" "M" "7" "C" "7" "" ""))
(DEFUN C:M8  () (COMMAND "LAYER" "N" "8" "M" "8" "C" "8" "" ""))
(DEFUN C:MW  () (COMMAND "LAYER" "N" "WIN" "M" "WIN" "C" "2" "" ""))
(DEFUN C:MD  () (COMMAND "LAYER" "N" "DIM" "M" "DIM" "C" "241" "" ""))
(DEFUN C:MDO () (COMMAND "LAYER" "N" "DOOR" "M" "DOOR" "C" "1" "" ""))
;...............................................
(defun C:MF()
   (while (not (setq en (entsel "\nSelect object to offset: "))))
   (setq mdist (getdist "\noffset Distance: "))
   (initget (+ 1 2 4))
   (setq mnum (getint "\nHow many times: "))
   (setq spt (getpoint "\nSelect side: "))
   (setq dist mdist)
   (repeat mnum
     (command "offset" dist en spt "")
     (setq dist (+ dist mdist))
   )
   (princ)
)
;...................................................
(DEFUN C:MID () (COMMAND "OSNAP" "MID"))
(DEFUN C:MS  () (COMMAND "MSLIDE"))
(DEFUN C:MSP () (COMMAND "MSPACE"))
;;;------------------------------LISP OF N-----------------------------------;
(DEFUN C:NC  () (COMMAND "SHELL" "NC"))
(DEFUN C:NEA () (COMMAND "OSNAP" "NEA"))
(DEFUN C:NOD () (COMMAND "OSNAP" "NOD"))
(DEFUN C:NON () (COMMAND "OSNAP" ""))
(DEFUN C:NN  () (COMMAND "OFFSET" ".1" PAUSE PAUSE "")(COMMAND "CHANGE" "L" "" "P" "LA" "2" "CO" "BYLAYER" ""))
(DEFUN C:NK  () (COMMAND "OFFSET" ".05" PAUSE PAUSE "")(COMMAND "CHANGE" "L" "" "P" "LA" "1" "CO" "BYLAYER" ""))

(PRINC)
;;;-----------------------------LISP OF O------------------------------------;
(DEFUN C:O   () (COMMAND "OFFSET"))
(DEFUN C:O1  () (COMMAND "LAYER" "ON" "1" "" ""))
(DEFUN C:O2  () (COMMAND "LAYER" "ON" "2" "" ""))
(DEFUN C:O3  () (COMMAND "LAYER" "ON" "3" "" ""))
(DEFUN C:O4  () (COMMAND "LAYER" "ON" "4" "" ""))
(DEFUN C:O5  () (COMMAND "LAYER" "ON" "5" "" ""))
(DEFUN C:O6  () (COMMAND "LAYER" "ON" "6" "" ""))
(DEFUN C:O7  () (COMMAND "LAYER" "ON" "7" "" ""))
(DEFUN C:O8  () (COMMAND "LAYER" "ON" "8" "" ""))
(DEFUN C:OW  () (COMMAND "LAYER" "ON" "WIN" "" ""))
(DEFUN C:ODO () (COMMAND "LAYER" "ON" "DOOR" "" ""))
(DEFUN C:OO  () (COMMAND "OFFSET" "T"))
(DEFUN C:OOP () (COMMAND "OOPS"))
(DEFUN C:OP  () (COMMAND "OPEN" "~"))
(DEFUN C:OS  () (COMMAND "OSNAP" "INT,END,PER,MID"))
(DEFUN C:OL  () (COMMAND "OSNAP" "INT,END,PER"))
;......................................................
(DEFUN C:ON  ()
		(SETQ A(GETSTRING "\nEnter layer's name:"))
		(COMMAND "LAYER" "ON" A "S" A "")
)
;................................................
(DEFUN C:OD ()
       (setq m:err *error* *error* *merr* osm (getvar "osmode")
             d2 (getvar "offsetdist"))(setvar "cmdecho" 0)
       (if   (<= d2 0) (setq d2 1))  (setq d1 (/ d2 2.0))(initget(+ 2 4))
       (setq d (getreal (strcat "Double offset distance.<"(rtos d2 2 2)">: "))p 1)
       (if   (/= d nil) (setq d (/ d 2.0)))
       (if   (= d nil) (setq d d1))
 (while (/= p nil)
  (DEFUN OS ()
              (setvar "osmode" 0)
              (command "offset" d p1 pt1 p1 pt2 "")
              (entdel(car p1))(setvar "osmode" osm)
              (setvar "offsetdist" (* d 2))
  )
             (setq p (entsel"\nSelect object to Doffset: ")p1 p)

   (if p (progn (setq p (entget (car p)) ent0 (assoc 0 p))
                        (cond
                         ((= (cdr ent0) "POLYLINE")
                          (setq epo1 (entget (entnext (cdr (car p))))
                                epo2 (entget (entnext (cdr (car epo1))))
                                po1 (cdr (assoc 10 epo1))
                                po2 (cdr (assoc 10 epo2))
                                ang (angle po1 po2) ang(+ (/ pi 2) ang)
                                pt1 (polar po1 ang 0.1)
                                pt2 (polar po1 (+ ang pi) 0.1))
                                (OS)
                         )

                         ((= (cdr ent0) "ARC")
                          (setq red (cdr (assoc 40 p))
                                cen (cdr (assoc 10 p))
                                ang (cdr (assoc 50 p))
                                pt1 (polar cen ang (- red 0.1))
                                pt2 (polar cen ang (+ red 0.1)))
                                (OS)
                         )

                         ((= (cdr ent0) "CIRCLE")
                          (setq red (cdr (assoc 40 p))
                                cen (cdr (assoc 10 p))
                                pt1 (polar cen 0 (- red 0.1))
                                pt2 (polar cen 0 (+ red 0.1)))
                                (OS)
                         )

                         ((= (cdr ent0) "LINE")
                          (setq po1 (cdr (assoc 10 p))
                                po2 (cdr (assoc 11 p))
                                ang (angle po1 po2) ang(+ (/ pi 2) ang)
                                pt1 (polar po1 ang 0.1)
                                pt2 (polar po1 (+ ang pi) 0.1))
                                (OS)
                         )

                         (T (princ "Cannot offset that entity")
                         )

                        )
         )
         (setq p nil)
   )
 )
(setq *error* m:err m:err nil)
)
(PRINC)
;;;-----------------------------LISP OF P------------------------------------;
(DEFUN C:pc  () (COMMAND "shell" "pc"))
(DEFUN C:PE  () (COMMAND "PEDIT"))
;(DEFUN C:PP  () (COMMAND "PEDIT" PAUSE "S" ""))
(DEFUN C:PP  () (COMMAND "PLAN" ""))
(DEFUN C:PER () (COMMAND "OSNAP" "PER"))
;(DEFUN C:PJ  () (COMMAND "PEDIT" PAUSE PAUSE "" "J" "P" PAUSE PAUSE "" "C" ""))
;(DEFUN C:PJ  () (COMMAND "PEDIT" PAUSE PAUSE "" "J" PAUSE PAUSE "C" ""))
(DEFUN C:PJ  () (COMMAND "PEDIT" PAUSE PAUSE "J"))
(DEFUN C:PL  () (COMMAND "PLINE"))
;.................................................
(defun c:pr ()
(setq vise (getpoint "\nget target point:"))
(setq h (getreal "\nheight:"))
(setq vise (list (car vise) (cadr vise) h))
(setq oeil (getpoint "\nget eye point:"))
(setq h (getreal "\nheight:"))
(setq oeil (list (car oeil) (cadr oeil) h))

        (command "dview"  "" "po" vise oeil  "d" "" "Z" "35" "x")
(setq change 1)
(while change
        (initget "z d nil h")
        (setq change
(getkword "\nZ for zoom  D for distance H for hide (nothing to exit)?"))

        (if (= change "d")
          (progn
           (prompt "\ndistance:") (print (distance vise oeil))
           (setq d (getreal "\nget new distance?"))
           (command "dview"  "" "po" vise oeil  "d" d "x")
          )
        )

        (if (= change "z")
          (progn
           (setq z (getreal "\nget zoom angle?"))
           (command "dview"  "" "po" vise oeil  "d" "" "z" z "x")
          )
        )

        (if (= change "h")
           (command "hide")
        )
        )
);fin d
;;:::::::::::::::::::::::::::::::::::::
(defun c:pon (/ dis)
  (setq dis (getdist "\nEnter distance "))
  (if
    (= dis nil)
    (command "dview" "" "d" "" "")
  )
  (if
    (/= dis nil)
    (command "dview" "" "d" dis "")
  )
)
;.................
(defun c:pof ()
  (command "dview" "" "off" "")
)
;...................................................
;(DEFUN C:PS  () (COMMAND "PSPACE"))
;;:::::::::::::::::::::::::::::::::::::::
(defun angtoc (ang)
  (setq ang
    (rtos (atof (angtos ang 0 8)) 2 6)
  )
  (strcat "<<" ang)
)

(if (not angtoc)                                              ;Test subroutines
  (prompt "\nRequires ANGTOC function. Load aborted. ")

(defun C:PT ( / midp radp txt radi txtlen txtspc txthgt cmd arclen
  arcang sang orent txtang txtp char)
  (setq cmdech (getvar "CMDECHO"))                  ;Save command echo
  (setvar "CMDECHO" 0)                              ;Turn command echo off
  (graphscr)
  (setq                                             ;Assign variables
    radp (getpoint "\nPick radius point: " )        ;Get radius point of text
    midp (getpoint "\nPick middle point of text: " radp) ;Get midpoint of text
    cmd
      (if (= 0 (setq txthgt
                     (cdr (assoc 40 (tblsearch "STYLE" (getvar "TEXTSTYLE")))
      )   )    )
        (progn                                      ;If height not fixed...
          (setq txthgt
            (getdist (strcat "\nText height <"      ;Get text height
                             (rtos (setq txt (getvar "TEXTSIZE"))) ;Default
                             ">: "
            )        )
            txthgt (if txthgt txthgt txt)           ;Set to default if nil
          );setq
          '(command "TEXT" "C" txtp txthgt txtang char) ;Assign command list
        );progn
        '(command "TEXT" "C" txtp txtang char)      ;Else fixed ht command list
      );end if
    txt (getstring "\nText: " T)                    ;Get text string
    radi (distance radp midp)                       ;Determine radius
    txtlen (strlen txt)                             ;Determine string length
    txtspc (cdr (assoc 41 (tblsearch "STYLE" (getvar "TEXTSTYLE")))) ;Char width
  );end variable assignment

  (setq orent         ;Get text orientation
    (strcase (getstring "\nIs base of text towards radius point <Y>: ")) ;Upper
  )

  ;; Calculate new radius length based on orientation
  (if (or (= orent "") (= orent "Y"))
    (setq radi (- radi (/ txthgt 2)))
    (setq radi (+ radi (/ txthgt 2)))
  );end if

  (setq                                   ;Calculate variables
    arclen (* txtlen txtspc txthgt)       ;Arc length
    txtspc (/ arclen txtlen)              ;Arc length of one character
    arcang (/ arclen radi)                ;Arc angle of one character
    sang (- (+ (angle radp midp) (/ arcang 2))   ;Start angle of text
            (/ txtspc radi 2)
         )
    count 1                               ;Initialize counter
  )

  (repeat txtlen                          ;Insert character loop
    (if (or (= orent "") (= orent "Y"))   ;Test text angle
        ;; Preface angle w/ << for universal angular units in dec. string
        (setq txtang (angtoc
                       (- sang (/ pi 2))  ;Convert start angle minus 90 deg
                     )
              txtpos count
        )
        ;; Calc angle for character towards radius and
        ;; character position in string
        (setq txtang (angtos (- sang (* pi 1.5)) 0) ;angle to command function
           txtpos (- (1+ txtlen) count)
        )
        ;; Calc angle for character away from radius and
        ;; character position in string
    )
    (setq txtp (polar radp sang radi))    ;Calculate character point
    (setq char (substr txt txtpos 1))     ;Get text character
    (eval cmd)                            ;Execute command list
    (setq count (1+ count))               ;Increment counter
    (setq sang (- sang (/ txtspc radi)))  ;Calculate new start angle
  );End repeat loop
  (setvar "CMDECHO" cmdech)               ;Turn command echo on
  (princ)                                 ;Ends program cleanly
);End defun
;*end of ATEXT2.LSP
;*
);test subroutines
;;::::::::::::::::::::::::::::::::::::::::::::::::
(defun c:PTT (/ ent1 pt1 txt tleng txtlst entlst
             loc ang loclst count ctx cht )
(setvar "cmdecho" 0)
(if (NOT (TBLSEARCH "BLOCK" "$CHAR"))
   (command "point" (getvar "viewctr")
        "block" "$char" (getvar "viewctr") "l" "")
)
(setq ent1 (entsel "\npick path for text: "))
(setq pt1 (cadr ent1))
(setq txt (getstring T "\Enter text: "))
(princ "please wait")
(setq tleng (strlen txt))
(command "divide" pt1 "b" "$char" "" (1+ tleng))
(setq txtlst '())
(setq count tleng)
(while (> count 0)
 (setq entlst (entget (entlast)))
 (setq loc (cdr (assoc 10 entlst)))
 (setq ang (* 57.2958(cdr (assoc 50 entlst))))
 (setq loclst (append loclst (list (cons loc ang))))
 (entdel (entlast))
 (princ ".")
 (setq count (1- count))
 )
 (setq count 1)
 (setq loclst (reverse loclst))
 (setvar "blipmode" 0)
  (while (< count (1+ tleng))
  (setq loc (car (car loclst)))
  (setq ang (cdr (car loclst)))
  (setq loclst (cdr loclst))
  (setq ctxt (getvar "textstyle"))
  (setq cht (cdr (assoc 40 (tblsearch "style" ctxt))))
  (if (= cht 0.0)
    (command "text" "C" loc "" ang (substr txt count 1))
    (command "text" "C" loc ang (substr txt count 1))
  )
   (setq count (1+ count))
  )
  (PRINC)
)
;........................................................
(DEFUN C:PW  () (COMMAND "PLAN"  "W" "" ))
(DEFUN C:PU  () (COMMAND "PURGE" "all" "y" "y" "y" "y" "y" "y" "y" "y" "y" ))
(PRINC)
;;;-----------------------------LISP OF Q------------------------------------;
(DEFUN C:QUA () (COMMAND "OSNAP" "QUA"))
(DEFUN C:Q   () (COMMAND "OFFSET"))
(DEFUN C:EW  () (COMMAND "CHANGE" "C" PAUSE PAUSE "" "P" "E"))
(DEFUN C:Q1  () (COMMAND "CHANGE" "C" PAUSE PAUSE "" "P" "LA" "1" "C" "BYLAYER" "" ""))
(DEFUN C:11  () (COMMAND "CHANGE" "C" PAUSE PAUSE "" "P" "LA" "1" "C" "BYLAYER" "" ""))
(DEFUN C:Q2  () (COMMAND "CHANGE" "C" PAUSE PAUSE "" "P" "LA" "2" "C" "BYLAYER" "" ""))
(DEFUN C:22  () (COMMAND "CHANGE" "C" PAUSE PAUSE "" "P" "LA" "2" "C" "BYLAYER" "" ""))
(DEFUN C:Q3  () (COMMAND "CHANGE" "C" PAUSE PAUSE "" "P" "LA" "3" "C" "BYLAYER" "" ""))
(DEFUN C:33  () (COMMAND "CHANGE" "C" PAUSE PAUSE "" "P" "LA" "3" "C" "BYLAYER" "" ""))
(DEFUN C:Q4  () (COMMAND "CHANGE" "C" PAUSE PAUSE "" "P" "LA" "4" "C" "BYLAYER" "" ""))
(DEFUN C:44  () (COMMAND "CHANGE" "C" PAUSE PAUSE "" "P" "LA" "4" "C" "BYLAYER" "" ""))
(DEFUN C:Q5  () (COMMAND "CHANGE" "C" PAUSE PAUSE "" "P" "LA" "5" "C" "BYLAYER" "" ""))
(DEFUN C:55  () (COMMAND "CHANGE" "C" PAUSE PAUSE "" "P" "LA" "5" "C" "BYLAYER" "" ""))
(DEFUN C:Q6  () (COMMAND "CHANGE" "C" PAUSE PAUSE "" "P" "LA" "6" "C" "BYLAYER" "" ""))
(DEFUN C:66  () (COMMAND "CHANGE" "C" PAUSE PAUSE "" "P" "LA" "6" "C" "BYLAYER" "" ""))
(DEFUN C:Q7  () (COMMAND "CHANGE" "C" PAUSE PAUSE "" "P" "LA" "7" "C" "BYLAYER" "" ""))
(DEFUN C:77  () (COMMAND "CHANGE" "C" PAUSE PAUSE "" "P" "LA" "7" "C" "BYLAYER" "" ""))
(DEFUN C:Q8  () (COMMAND "CHANGE" "C" PAUSE PAUSE "" "P" "LA" "8" "C" "BYLAYER" "" ""))
(DEFUN C:88  () (COMMAND "CHANGE" "C" PAUSE PAUSE "" "P" "LA" "8" "C" "BYLAYER" "" ""))
(DEFUN C:QW  () (COMMAND "CHANGE" "C" PAUSE PAUSE "" "P" "LA" "WIN" "C" "BYLAYER" "" ""))
(DEFUN C:QD  () (COMMAND "CHANGE" "C" PAUSE PAUSE "" "P" "LA" "DIM" "C" "BYLAYER" "" ""))
(DEFUN C:QDD  () (COMMAND "CHANGE" "C" PAUSE PAUSE "" "P" "LA" "DOOR" "C" "BYLAYER" "" ""))
(DEFUN C:QB  () (COMMAND "CHANGE" "C" PAUSE PAUSE "" "P" "LA" "BLOCK" "C" "BYLAYER" "" ""))
(PRINC)
;;;-----------------------------LISP OF R------------------------------------;
(DEFUN C:R   () (COMMAND "REDRAW"))
(DEFUN C:RR  () (COMMAND "ROTATE"))
;(DEFUN C:RD  ([Scale]$M=$(if,$(eq,$(substr,$(getvar,cmdnames),1,4),GRIP),_scale,^C^C_scale)
;[Stretch]$M=$(if,$(eq,$(substr,$(getvar,cmdnames),1,4),GRIP),_stretch,^C^C_stretch _c)

;..........................................................
(defun C:RC ( / head hdata bulge en ed)
 (if (and
   (setq en (entsel "\nselect a polyline: "))
   ( = (dxf 0 (setq hdata (entget (car en)))) "POLYLINE")
   )
   (progn
    (entmod (subst '(70 . 1) '(70 . 0) hdata))
    (setq bulge (list (cons 42 0.5)))
    (setq en (dxf -1 hdata))
    (while (and (setq en (entnext en))
       (setq ed (entget en))
       (/= "SEQEND" (dxf 0 ed))
     )
     (setq ed (append ed bulge))
     (entmod ed)
    )
    (entupd en)
  )
 )
)
(princ)
(defun dxf (code elist)
  (cdr (assoc code elist))
)
;....................................................
(DEFUN C:RG  () (COMMAND "REGEN"))
(DEFUN C:RE  () (COMMAND "ROTATE"  "C"  PAUSE PAUSE  PAUSE PAUSE "45"))
(DEFUN C:RT  () (COMMAND "ROTATE"  "C"  PAUSE PAUSE  PAUSE PAUSE "-45"))
(DEFUN C:RW  () (COMMAND "ROTATE"  "C"  PAUSE PAUSE  PAUSE PAUSE "90"))
(DEFUN C:RY  () (COMMAND "ROTATE"  "C"  PAUSE PAUSE  PAUSE PAUSE "-90"))
(DEFUN C:RQ  () (COMMAND "ROTATE"  "C"  PAUSE PAUSE  PAUSE PAUSE "180"))
;;;-----------------------------LISP OF S------------------------------------;
(DEFUN C:S   () (COMMAND "Stretch" "C" PAUSE PAUSE "R"))
(DEFUN C:SO  () (COMMAND "SOLID"))
(DEFUN C:S30 () (COMMAND "SNAP" "R" "0,0" "30" "")(COMMAND "SNAP" "OFF"))
(DEFUN C:S45 () (COMMAND "SNAP" "R" "0,0" "45" "")(COMMAND "SNAP" "OFF")) 
(DEFUN C:S60 () (COMMAND "SNAP" "R" "0,0" "60" "")(COMMAND "SNAP" "OFF"))
(DEFUN C:SA  () (COMMAND "SAVE" ""))
(DEFUN C:SD  () (COMMAND "SPLINE"))
(DEFUN C:sc  () (COMMAND "scale"))
(DEFUN C:sc3 () (COMMAND "scale" "c" PAUSE PAUSE  PAUSE PAUSE  ".3"))
(DEFUN C:sc5 () (COMMAND "scale" "c" PAUSE PAUSE  PAUSE PAUSE  ".5"))
(DEFUN C:sc7 () (COMMAND "scale" "c" PAUSE PAUSE  PAUSE PAUSE  ".7"))
(DEFUN C:sc8 () (COMMAND "scale" "c" PAUSE PAUSE  PAUSE PAUSE  ".8"))
(DEFUN C:sc9 () (COMMAND "scale" "c" PAUSE PAUSE  PAUSE PAUSE  ".9"))
(DEFUN C:sc99 () (COMMAND "scale" "c" PAUSE PAUSE  PAUSE PAUSE  ".95"))
(DEFUN C:s11 () (COMMAND "scale" "c" PAUSE PAUSE  PAUSE PAUSE  "1.1"))
(DEFUN C:s12 () (COMMAND "scale" "c" PAUSE PAUSE  PAUSE PAUSE  "1.2"))
(DEFUN C:s13 () (COMMAND "scale" "c" PAUSE PAUSE  PAUSE PAUSE  "1.3"))
(DEFUN C:s14 () (COMMAND "scale" "c" PAUSE PAUSE  PAUSE PAUSE  "1.4"))
(DEFUN C:s15 () (COMMAND "scale" "c" PAUSE PAUSE  PAUSE PAUSE  "1.5"))
(DEFUN C:s17 () (COMMAND "scale" "c" PAUSE PAUSE  PAUSE PAUSE  "1.7"))
(DEFUN C:s2  () (COMMAND "scale" "c" PAUSE PAUSE  PAUSE PAUSE  "2"))
(DEFUN C:SE  () (COMMAND "SELECT"))
(DEFUN C:SF1 () (COMMAND "SURFTAB1"))
(DEFUN C:SF2 () (COMMAND "SURFTAB2"))
(DEFUN C:SHH () (COMMAND "SHADE"))
(DEFUN C:ST  () (COMMAND "STYLE"))
(DEFUN C:SSA () (COMMAND "CHANGE" PAUSE "" "" "" "SADE" "" "" "" ""))
(DEFUN C:SCH () (COMMAND "CHANGE" PAUSE "" "" "" "CHAPI" "" "" "" ""))
(DEFUN C:SNN () (COMMAND "CHANGE" PAUSE "" "" "" "NASKHN" "" "" "" ""))
(DEFUN C:SND () (COMMAND "CHANGE" PAUSE "" "" "" "NASKHD" "" "" "" ""))
(DEFUN C:SNS () (COMMAND "CHANGE" PAUSE "" "" "" "NASKHS" "" "" "" ""))
(DEFUN C:STH () (COMMAND "CHANGE" PAUSE "" "" "" "TAHRIR1" "" "" "" ""))
(DEFUN C:STA () (COMMAND "CHANGE" PAUSE "" "" "" "TRAFIC" "" "" "" ""))
(DEFUN C:SRD () (COMMAND "STYLE" "ROMAND" "ROMAND" "" "" "" "" "" ""))
(DEFUN C:SRT () (COMMAND "STYLE" "ROMANT" "ROMANT" "" "" "" "" "" ""))
(DEFUN C:SRC () (COMMAND "STYLE" "ROMANC" "ROMANC" "" "" "" "" "" ""))
(DEFUN C:STC () (COMMAND "STYLE" "CHAPI" "CHAPI" "" "" "" "y" "" ""))
(DEFUN C:STS () (COMMAND "STYLE" "SADE" "SADE" "" "" "" "y" "" ""))
(PRINC)

;.........................................................
;change the X,Y and Z scale of existing blocks without affecting
;properties or attributes.
(defun C:SCC ( / en edold41 old42 old43 new41 new42 new43)
(if (and (setq en (entsel  "\select block to rescale: "))
      ( = (dxf 0 (setq ed (entget (car en)))) "INSERT")
  )
  (entmod
    (setq
      old41 (dxf 41 ed)
      old42 (dxf 42 ed)
      old43 (dxf 43 ed)
      new41 (ureal "X scale factor" old41)
      new42 (ureal "Y scale factor" old42)
      new43 (ureal "Z scale factor" old43)
      ed (subst (cons 41 new41) (cons 41 old41) ed)
      ed (subst (cons 42 new42) (cons 42 old42) ed)
      ed (subst (cons 43 new43) (cons 43 old43) ed)
     )
    )
   )
)
(defun dxf (code elist)
   (cdr (assoc code elist))
)
(defun ureal (msg def / inp)
   (setq msg (strcat "\n" msg "<" (rtos def 2) ">:"))
   (initget ( + 2 4))
   (setq inp (getreal msg))
   (if inp inp def)
)
;.....................set style text................
(defun c:ss()
(setq a (entget (car (entsel "select text with desire style : "))))
(setq b (cdr (assoc 7 a)))
(command "text" "s" b "0,0" ""  "" "")
)
;.......................................................................
(PRINC)
;;;-----------------------------LISP OF T------------------------------------;
(DEFUN C:TF  () (COMMAND "TRIM" PAUSE PAUSE "F"))
(DEFUN C:T   () (COMMAND "TRIM"))
;(DEFUN C:TT  () (COMMAND "EXTRIM"))
(DEFUN C:TAN () (COMMAND "OSNAP" "TAN"))
(DEFUN C:TE  () (COMMAND "LAYER" "t" "test" "on" "test" "S" "TEST" ""))
(DEFUN C:TEE () (COMMAND "LAYER" "t" "0" "ON" "0" "S" "0" "F" "TEST" ""))
(DEFUN C:TOO () (COMMAND "SHELL" "TOOLKIT"))
(DEFUN C:TR  () (COMMAND "TRACE"))
;......................................................
;;;------------------------------LISP OF U-----------------------------------;
;;;CHANGE ANGLE FOR USER CORDINATE SYSTEM
(DEFUN C:U3  () (COMMAND "UCS" "3" ))
(DEFUN C:UC  () (COMMAND "UCS" ))
(DEFUN C:UE  () (COMMAND "UCS" "E" ))
(DEFUN C:UIO () (COMMAND "UCSICON" "ON" ))
(DEFUN C:UIF () (COMMAND "UCSICON" "OFF" ))
(DEFUN C:UO  () (COMMAND "UCS" "O"))
(DEFUN C:US  () (COMMAND "UCS" "S"))
(DEFUN C:UW  () (COMMAND "UCS" "" ))
(DEFUN C:UWW () (COMMAND "UCS" "" "UCS" "O"))
(DEFUN C:UV  () (COMMAND "UCS" "V" ))
(DEFUN C:UU  () (COMMAND "UCS" "P" ))
(DEFUN C:UUE () (COMMAND "UCS" "R" "E" "UCS" "O"))
(DEFUN C:UUN () (COMMAND "UCS" "R" "N" "UCS" "O"))
(DEFUN C:UUS () (COMMAND "UCS" "R" "S" "UCS" "O"))
(DEFUN C:UUW () (COMMAND "UCS" "R" "W" "UCS" "O"))
(DEFUN C:UX  () (COMMAND "UCS" "X" "90" ))
(DEFUN C:UY  () (COMMAND "UCS" "Y" "90" ))
(DEFUN C:UZ  () (COMMAND "UCS" "Z" "45" ))
(PRINC)
;;;-----------------------------LISP OF V------------------------------------;
(DEFUN C:V   () (COMMAND "VPOINT"))
(DEFUN C:VI  () (COMMAND "VIEW"))
(DEFUN C:VS  () (COMMAND "VSLIDE"))
(DEFUN C:VR  () (COMMAND "VIEW" "R"))
(DEFUN C:VV  () (COMMAND "VIEW" "R" "V"))
(DEFUN C:VF  () (COMMAND "VPOINT" "0,-1,0"))
(DEFUN C:VB  () (COMMAND "VPOINT" "0,1,0"))
(DEFUN C:VD  () (COMMAND "VPOINT" "-1,0,0"))
(DEFUN C:VG  () (COMMAND "VPOINT" "1,0,0"))
(PRINC)
;;;-------------------------------LISP OF W----------------------------------;

(DEFUN C:WB  () (COMMAND "WBLOCK" "~"))
(DEFUN C:W0  () (COMMAND "PEDIT" PAUSE "" "J" "P" "" "W" "0" ""))
(DEFUN C:W3  () (COMMAND "PEDIT" PAUSE "" "J" "P" "" "W" ".03" ""))
(DEFUN C:W4  () (COMMAND "PEDIT" PAUSE "" "J" "P" "" "W" ".04" ""))
(DEFUN C:W04 () (COMMAND "PEDIT" PAUSE "" "J" "P" "" "W" ".004" ""))
(DEFUN C:W5  () (COMMAND "PEDIT" PAUSE "" "J" "P" "" "W" ".05" ""))
(DEFUN C:W05 () (COMMAND "PEDIT" PAUSE "" "J" "P" "" "W" ".005" ""))
(DEFUN C:W6  () (COMMAND "PEDIT" PAUSE "" "J" "P" "" "W" ".06" ""))
(DEFUN C:W7  () (COMMAND "PEDIT" PAUSE "" "J" "P" "" "W" ".07" ""))
(DEFUN C:W8  () (COMMAND "PEDIT" PAUSE "" "J" "P" "" "W" ".08" ""))
(DEFUN C:W1  () (COMMAND "PEDIT" PAUSE "" "J" "P" "" "W" ".1" ""))
(DEFUN C:W12 () (COMMAND "PEDIT" PAUSE "" "J" "P" "" "W" ".12" ""))
;(DEFUN C:W3 () (COMMAND "PEDIT" PAUSE "W" ".03" ""))
;(DEFUN C:W4 () (COMMAND "PEDIT" PAUSE "W" ".04" ""))
(DEFUN C:WW  () (COMMAND "EXTEND"))
(DEFUN C:W   () (SETQ NO (GETSTRING "\nENTER WIDTH FROM POLYLINE:"))(COMMAND "PEDIT" "C" PAUSE PAUSE "W" NO ""))
(DEFUN C:WL  () (SETQ NO (GETSTRING "\nENTER WIDTH FROM LINE:"))(COMMAND "PEDIT" "C" PAUSE PAUSE "" "W" NO ""))
(PRINC)
;;;-------------------------------LISP OF X----------------------------------;
(DEFUN C:V   () (COMMAND "VPOINT"))
(DEFUN C:VI  () (COMMAND "VIEW"))
(DEFUN C:VS  () (COMMAND "VSLIDE"))
(DEFUN C:VR  () (COMMAND "VIEW" "R"))
(DEFUN C:VV  () (COMMAND "VIEW" "R" "V"))
(DEFUN C:VX  () (COMMAND "VPOINT" "1,0,0"))
(DEFUN C:VY  () (COMMAND "VPOINT" "0,1,0"))
    (PRINC)

;;;-------------------------------LISP OF Y----------------------------------;
;;;-------------------------------LISP OF Z----------------------------------;
(DEFUN C:Z   () (COMMAND "ZOOM" ))
(DEFUN C:X   () (COMMAND "ZOOM" ))
(DEFUN C:ZA  () (COMMAND "ZOOM" "A"))
(DEFUN C:ZC  () (COMMAND "ZOOM" "C"))
(DEFUN C:ZD  () (COMMAND "ZOOM" "D"))
(DEFUN C:ZE  () (COMMAND "ZOOM" "E"))
(DEFUN C:ZX  () (COMMAND "ZOOM" ".6X"))
(DEFUN C:ZXX () (COMMAND "ZOOM" ".4X"))
(DEFUN C:ZV  () (COMMAND "ZOOM" "V"))
(DEFUN C:zs  () (COMMAND "zoom" "1.5x"))
(DEFUN C:zss () (COMMAND "zoom" "3x"))
(DEFUN C:ZZ  () (COMMAND "ZOOM" "P"))
(DEFUN C:XX  () (COMMAND "ZOOM" "P"))
(PRINC)
;;;-----------------LISP OF NUMBER IN UINT CENTEMETR----------------------;
(DEFUN C:1   () (COMMAND "offset" "1" ))
(DEFUN C:2   () (COMMAND "offset" "2" ))
(DEFUN C:3   () (COMMAND "offset" "3" ))
(DEFUN C:4   () (COMMAND "offset" "4" ))
(DEFUN C:5   () (COMMAND "offset" "5" ))
(DEFUN C:6   () (COMMAND "offset" "6" ))
(DEFUN C:7   () (COMMAND "offset" "7" ))
(DEFUN C:8   () (COMMAND "offset" "8" ))
(DEFUN C:9   () (COMMAND "offset" "9" ))
(DEFUN C:10  () (COMMAND "offset" "10"))
(DEFUN C:12  () (COMMAND "offset" "12"))
(DEFUN C:15  () (COMMAND "offset" "15"))
(DEFUN C:16  () (COMMAND "offset" "16"))
(DEFUN C:20  () (COMMAND "offset" "20"))
(DEFUN C:25  () (COMMAND "offset" "25"))
(DEFUN C:30  () (COMMAND "offset" "30"))
(DEFUN C:35  () (COMMAND "offset" "35"))
(DEFUN C:40  () (COMMAND "offset" "40"))
(DEFUN C:45  () (COMMAND "offset" "45"))
(DEFUN C:50  () (COMMAND "offset" "50"))
;(DEFUN C:55  () (COMMAND "offset" "55"))
(DEFUN C:60  () (COMMAND "offset" "60"))
(DEFUN C:65  () (COMMAND "offset" "65"))
(DEFUN C:70  () (COMMAND "offset" "70"))
(DEFUN C:75  () (COMMAND "offset" "75"))
(DEFUN C:80  () (COMMAND "offset" "80"))
(DEFUN C:85  () (COMMAND "offset" "85"))
(DEFUN C:90  () (COMMAND "offset" "90"))
(DEFUN C:95  () (COMMAND "offset" "95"))
(DEFUN C:100 () (COMMAND "offset" "100"))
(DEFUN C:115  () (COMMAND "offset" "115"))
(DEFUN C:120  () (COMMAND "offset" "120"))
(DEFUN C:125  () (COMMAND "offset" "125"))
(DEFUN C:130  () (COMMAND "offset" "130"))
(DEFUN C:135  () (COMMAND "offset" "135"))
(DEFUN C:140  () (COMMAND "offset" "140"))
(DEFUN C:145  () (COMMAND "offset" "145"))
(DEFUN C:150  () (COMMAND "offset" "150"))
;;;-----------------LISP OF NUMBER IN UINT METRIC----------------------;
(DEFUN C:/02  () (COMMAND "offset" ".02"))
(DEFUN C:/03  () (COMMAND "offset" ".03"))
(DEFUN C:/04  () (COMMAND "offset" ".04"))
(DEFUN C:/05  () (COMMAND "offset" ".05"))
(DEFUN C:/06  () (COMMAND "offset" ".06"))
(DEFUN C:/07  () (COMMAND "offset" ".07"))
(DEFUN C:/08  () (COMMAND "offset" ".08"))
(DEFUN C:/09  () (COMMAND "offset" ".09"))
(DEFUN C:/1   () (COMMAND "offset" ".1"))
(DEFUN C:/15  () (COMMAND "offset" ".15"))
(DEFUN C:/2   () (COMMAND "offset" ".2"))
(DEFUN C:/25  () (COMMAND "offset" ".25"))
(DEFUN C:/3   () (COMMAND "offset" ".3"))
(DEFUN C:/35  () (COMMAND "offset" ".35"))
(DEFUN C:/4   () (COMMAND "offset" ".4"))
(DEFUN C:/45  () (COMMAND "offset" ".45"))
(DEFUN C:/5   () (COMMAND "offset" ".5"))
(DEFUN C:/55  () (COMMAND "offset" ".55"))
(DEFUN C:/6   () (COMMAND "offset" ".6"))
(DEFUN C:/65  () (COMMAND "offset" ".65"))
(DEFUN C:/7   () (COMMAND "offset" ".7"))
(DEFUN C:/75  () (COMMAND "offset" ".75"))
(DEFUN C:/8   () (COMMAND "offset" ".8"))
(DEFUN C:/85  () (COMMAND "offset" ".85"))
(DEFUN C:/9   () (COMMAND "offset" ".9"))
(DEFUN C:/95  () (COMMAND "offset" ".95"))
(DEFUN C:1    () (COMMAND "offset" "1"))
(DEFUN C:1/05 () (COMMAND "offset" "1.05"))
(DEFUN C:1/1  () (COMMAND "offset" "1.1"))
(DEFUN C:1/15 () (COMMAND "offset" "1.15"))
(DEFUN C:1/2  () (COMMAND "offset" "1.2"))
(DEFUN C:1/25 () (COMMAND "offset" "1.25"))
(DEFUN C:1/3  () (COMMAND "offset" "1.3"))
(DEFUN C:1/35 () (COMMAND "offset" "1.35"))
(DEFUN C:1/4  () (COMMAND "offset" "1.4"))
(DEFUN C:1/45 () (COMMAND "offset" "1.45"))
(DEFUN C:1/5  () (COMMAND "offset" "1.5"))
(DEFUN C:1/55 () (COMMAND "offset" "1.55"))
(DEFUN C:1/6  () (COMMAND "offset" "1.6"))
(DEFUN C:1/65 () (COMMAND "offset" "1.65"))
(DEFUN C:1/7  () (COMMAND "offset" "1.7"))
(DEFUN C:1/75 () (COMMAND "offset" "1.75"))
(DEFUN C:1/8  () (COMMAND "offset" "1.8"))
(DEFUN C:1/85 () (COMMAND "offset" "1.85"))
(DEFUN C:1/9  () (COMMAND "offset" "1.9"))
(DEFUN C:1/95 () (COMMAND "offset" "1.95"))
(DEFUN C:2    () (COMMAND "offset" "2"))
(DEFUN C:2/05 () (COMMAND "offset" "2.05"))
(DEFUN C:2/1  () (COMMAND "offset" "2.1"))
(DEFUN C:2/15 () (COMMAND "offset" "2.15"))
(DEFUN C:2/2  () (COMMAND "offset" "2.2"))
(DEFUN C:2/25 () (COMMAND "offset" "2.25"))
(DEFUN C:2/3  () (COMMAND "offset" "2.3"))
(DEFUN C:2/35 () (COMMAND "offset" "2.35"))
(DEFUN C:2/4  () (COMMAND "offset" "2.4"))
(DEFUN C:2/45 () (COMMAND "offset" "2.45"))
(DEFUN C:2/5  () (COMMAND "offset" "2.5"))
(DEFUN C:2/55 () (COMMAND "offset" "2.55"))
(DEFUN C:2/6  () (COMMAND "offset" "2.6"))
(DEFUN C:2/65 () (COMMAND "offset" "2.65"))
(DEFUN C:2/7  () (COMMAND "offset" "2.7"))
(DEFUN C:2/75 () (COMMAND "offset" "2.75"))
(DEFUN C:2/8  () (COMMAND "offset" "2.8"))
(DEFUN C:2/85 () (COMMAND "offset" "2.85"))
(DEFUN C:2/9  () (COMMAND "offset" "2.9"))
(DEFUN C:2/95 () (COMMAND "offset" "2.95"))
(DEFUN C:3    () (COMMAND "offset" "3"))
(DEFUN C:3/05 () (COMMAND "offset" "3.05"))
(DEFUN C:3/1  () (COMMAND "offset" "3.1"))
(DEFUN C:3/15 () (COMMAND "offset" "3.15"))
(DEFUN C:3/2  () (COMMAND "offset" "3.2"))
(DEFUN C:3/25 () (COMMAND "offset" "3.25"))
(DEFUN C:3/3  () (COMMAND "offset" "3.3"))
(DEFUN C:3/35 () (COMMAND "offset" "3.35"))
(DEFUN C:3/4  () (COMMAND "offset" "3.4"))
(DEFUN C:3/45 () (COMMAND "offset" "3.45"))
(DEFUN C:3/5  () (COMMAND "offset" "3.5"))
(DEFUN C:3/55 () (COMMAND "offset" "3.55"))
(DEFUN C:3/6  () (COMMAND "offset" "3.6"))
(DEFUN C:3/65 () (COMMAND "offset" "3.65"))
(DEFUN C:3/7  () (COMMAND "offset" "3.7"))
(DEFUN C:3/75 () (COMMAND "offset" "3.75"))
(DEFUN C:3/8  () (COMMAND "offset" "3.8"))
(DEFUN C:3/85 () (COMMAND "offset" "3.85"))
(DEFUN C:3/9  () (COMMAND "offset" "3.9"))
(DEFUN C:3/95 () (COMMAND "offset" "3.95"))
(DEFUN C:4    () (COMMAND "offset" "4"))
(DEFUN C:4/1  () (COMMAND "offset" "4.1"))
(DEFUN C:4/15 () (COMMAND "offset" "4.15"))
(DEFUN C:4/2  () (COMMAND "offset" "4.2"))
(DEFUN C:4/25 () (COMMAND "offset" "4.25"))
(DEFUN C:4/3  () (COMMAND "offset" "4.3"))
(DEFUN C:4/35 () (COMMAND "offset" "4.35"))
(DEFUN C:4/4  () (COMMAND "offset" "4.4"))
(DEFUN C:4/45 () (COMMAND "offset" "4.45"))
(DEFUN C:4/5  () (COMMAND "offset" "4.5"))
(DEFUN C:4/55 () (COMMAND "offset" "4.55"))
(DEFUN C:4/6  () (COMMAND "offset" "4.6"))
(DEFUN C:4/65 () (COMMAND "offset" "4.65"))
(DEFUN C:4/7  () (COMMAND "offset" "4.7"))
(DEFUN C:4/75 () (COMMAND "offset" "4.75"))
(DEFUN C:4/8  () (COMMAND "offset" "4.8"))
(DEFUN C:4/85 () (COMMAND "offset" "4.85"))
(DEFUN C:4/9  () (COMMAND "offset" "4.9"))
(DEFUN C:4/95 () (COMMAND "offset" "4.95"))
(DEFUN C:5    () (COMMAND "offset" "5"))
(DEFUN C:5/05 () (COMMAND "offset" "5.05"))
(DEFUN C:5/1  () (COMMAND "offset" "5.1"))
(DEFUN C:5/15 () (COMMAND "offset" "5.15"))
(DEFUN C:5/2  () (COMMAND "offset" "5.2"))
(DEFUN C:5/25 () (COMMAND "offset" "5.25"))
(DEFUN C:5/3  () (COMMAND "offset" "5.3"))
(DEFUN C:5/35 () (COMMAND "offset" "5.35"))
(DEFUN C:5/4  () (COMMAND "offset" "5.4"))
(DEFUN C:5/45 () (COMMAND "offset" "5.45"))
(DEFUN C:5/5  () (COMMAND "offset" "5.5"))
(DEFUN C:5/55 () (COMMAND "offset" "5.55"))
(DEFUN C:5/6  () (COMMAND "offset" "5.6"))
(DEFUN C:5/65 () (COMMAND "offset" "5.65"))
(DEFUN C:5/7  () (COMMAND "offset" "5.7"))
(DEFUN C:5/75 () (COMMAND "offset" "5.75"))
(DEFUN C:5/8  () (COMMAND "offset" "5.8"))
(DEFUN C:5/85 () (COMMAND "offset" "5.85"))
(DEFUN C:5/9  () (COMMAND "offset" "5.9"))
(DEFUN C:5/95 () (COMMAND "offset" "5.95"))
(DEFUN C:6    () (COMMAND "offset" "6"))
(DEFUN C:6/05 () (COMMAND "offset" "6.05"))
(DEFUN C:6/1  () (COMMAND "offset" "6.1"))
(DEFUN C:6/15 () (COMMAND "offset" "6.15"))
(DEFUN C:6/2  () (COMMAND "offset" "6.2"))
(DEFUN C:6/25 () (COMMAND "offset" "6.25"))
(DEFUN C:6/3  () (COMMAND "offset" "6.3"))
(DEFUN C:6/35 () (COMMAND "offset" "6.35"))
(DEFUN C:6/4  () (COMMAND "offset" "6.4"))
(DEFUN C:6/45 () (COMMAND "offset" "6.45"))
(DEFUN C:6/5  () (COMMAND "offset" "6.5"))
(DEFUN C:6/55 () (COMMAND "offset" "6.55"))
(DEFUN C:6/6  () (COMMAND "offset" "6.6"))
(DEFUN C:6/65 () (COMMAND "offset" "6.65"))
(DEFUN C:6/7  () (COMMAND "offset" "6.7"))
(DEFUN C:6/75 () (COMMAND "offset" "6.75"))
(DEFUN C:6/8  () (COMMAND "offset" "6.8"))
(DEFUN C:6/85 () (COMMAND "offset" "6.85"))
(DEFUN C:6/9  () (COMMAND "offset" "6.9"))
(DEFUN C:6/95 () (COMMAND "offset" "6.95"))
(DEFUN C:7    () (COMMAND "offset" "7"))
(DEFUN C:7/05 () (COMMAND "offset" "7.05"))
(DEFUN C:7/1  () (COMMAND "offset" "7.1"))
(DEFUN C:7/15 () (COMMAND "offset" "7.15"))
(DEFUN C:7/2  () (COMMAND "offset" "7.2"))
(DEFUN C:7/25 () (COMMAND "offset" "7.25"))
(DEFUN C:7/3  () (COMMAND "offset" "7.3"))
(DEFUN C:7/35 () (COMMAND "offset" "7.35"))
(DEFUN C:7/4  () (COMMAND "offset" "7.4"))
(DEFUN C:7/45 () (COMMAND "offset" "7.45"))
(DEFUN C:7/5  () (COMMAND "offset" "7.5"))
(DEFUN C:7/55 () (COMMAND "offset" "7.55"))
(DEFUN C:7/6  () (COMMAND "offset" "7.6"))
(DEFUN C:7/65 () (COMMAND "offset" "7.65"))
(DEFUN C:7/7  () (COMMAND "offset" "7.7"))
(DEFUN C:7/75 () (COMMAND "offset" "7.75"))
(DEFUN C:7/8  () (COMMAND "offset" "7.8"))
(DEFUN C:7/85 () (COMMAND "offset" "7.85"))
(DEFUN C:7/9  () (COMMAND "offset" "7.9"))
(DEFUN C:7/95 () (COMMAND "offset" "7.95"))
(DEFUN C:8    () (COMMAND "offset" "8"))
(DEFUN C:8/05 () (COMMAND "offset" "8.05"))
(DEFUN C:8/1  () (COMMAND "offset" "8.1"))
(DEFUN C:8/15 () (COMMAND "offset" "8.15"))
(DEFUN C:8/2  () (COMMAND "offset" "8.2"))
(DEFUN C:8/25 () (COMMAND "offset" "8.25"))
(DEFUN C:8/3  () (COMMAND "offset" "8.3"))
(DEFUN C:8/35 () (COMMAND "offset" "8.35"))
(DEFUN C:8/4  () (COMMAND "offset" "8.4"))
(DEFUN C:8/45 () (COMMAND "offset" "8.45"))
(DEFUN C:8/5  () (COMMAND "offset" "8.5"))
(DEFUN C:8/55 () (COMMAND "offset" "8.55"))
(DEFUN C:8/6  () (COMMAND "offset" "8.6"))
(DEFUN C:8/65 () (COMMAND "offset" "8.65"))
(DEFUN C:8/7  () (COMMAND "offset" "8.7"))
(DEFUN C:8/75 () (COMMAND "offset" "8.75"))
(DEFUN C:8/8  () (COMMAND "offset" "8.8"))
(DEFUN C:8/85 () (COMMAND "offset" "8.85"))
(DEFUN C:8/9  () (COMMAND "offset" "8.9"))
(DEFUN C:8/95 () (COMMAND "offset" "8.95"))
(DEFUN C:9    () (COMMAND "offset" "9"))
(DEFUN C:9/05 () (COMMAND "offset" "9.05"))
(DEFUN C:9/1  () (COMMAND "offset" "9.1"))
(DEFUN C:9/15 () (COMMAND "offset" "9.15"))
(DEFUN C:9/2  () (COMMAND "offset" "9.2"))
(DEFUN C:9/25 () (COMMAND "offset" "9.25"))
(DEFUN C:9/3  () (COMMAND "offset" "9.3"))
(DEFUN C:9/35 () (COMMAND "offset" "9.35"))
(DEFUN C:9/4  () (COMMAND "offset" "9.4"))
(DEFUN C:9/45 () (COMMAND "offset" "9.45"))
(DEFUN C:9/5  () (COMMAND "offset" "9.5"))
(DEFUN C:9/55 () (COMMAND "offset" "9.55"))
(DEFUN C:9/6  () (COMMAND "offset" "9.6"))
(DEFUN C:9/65 () (COMMAND "offset" "9.65"))
(DEFUN C:9/7  () (COMMAND "offset" "9.7"))
(DEFUN C:9/75 () (COMMAND "offset" "9.75"))
(DEFUN C:9/8  () (COMMAND "offset" "9.8"))
(DEFUN C:9/85 () (COMMAND "offset" "9.85"))
(DEFUN C:9/9  () (COMMAND "offset" "9.9"))
(DEFUN C:9/95 () (COMMAND "offset" "9.95"))
(DEFUN C:10   () (COMMAND "offset" "10"))
;;/////////////////////////////////////////////

